import coverage
import unittest
loader = unittest.TestLoader()
cov = coverage.Coverage(source=[
    "emodpy_tbhiv.demographics.TBHIVDemographics"
    , "emodpy_tbhiv.interventions.active_diagnostic"
    , "emodpy_tbhiv.interventions.art"
    , "emodpy_tbhiv.interventions.bcg"
    , "emodpy_tbhiv.interventions.cd4diag"
    , "emodpy_tbhiv.interventions.diag_treat_neg"
    , "emodpy_tbhiv.interventions.hiv_diag"
    , "emodpy_tbhiv.interventions.hiv_seeding"
    , "emodpy_tbhiv.interventions.hsb"
    , "emodpy_tbhiv.interventions.ramp_dtn"
    , "emodpy_tbhiv.interventions.resist_diag"
    , "emodpy_tbhiv.interventions.smear_diag"
    , "emodpy_tbhiv.interventions.sub_clinical_test"
    , "emodpy_tbhiv.interventions.tb_treat_basic"
    , "emodpy_tbhiv.interventions.tb_treat_pddrug"
    , "emodpy_tbhiv.interventions.tbhiv_treat"
    , "emodpy_tbhiv.interventions.triggered_pvc"
    , "emodpy_tbhiv.interventions.vaccine"
])
cov.start()

# First, load and run the unittest tests
from test_ad import TestAD
from test_bcg import TestBCG
from test_art import TestART
from test_cd4diag import Testcd4diag
from test_dtn import TestDTN
from test_hivdiag import Testhivdiag
from test_hivseed import Testhivseed
from test_hsb import Testhsb
from test_ramp import Testramp
from test_resistdiag import Testresistdiag
from test_smeardiag import Testsmeardiag
from test_tbhivtreat import Testtbhivtreat
from test_tbtreat import Testtbtreat
from test_tpvc import Testtpvc
from test_vacc import Testvacc

test_classes_to_run = [TestAD, TestBCG, TestART, Testcd4diag, TestDTN,
                       Testhivdiag, Testhivseed, Testhsb, Testramp,
                       Testresistdiag, Testsmeardiag, Testtbhivtreat,
                       Testtbtreat, Testtpvc, Testvacc]

suites_list = []
for tc in test_classes_to_run:
    suite = loader.loadTestsFromTestCase(tc)
    suites_list.append(suite)
    pass

big_suite = unittest.TestSuite(suites_list)
runner = unittest.TextTestRunner()
results = runner.run(big_suite)

cov.stop()
cov.save()
cov.html_report()